## com.google.javascript.rhino.jstype
Class TemplateType

    java.lang.Object
      com.google.javascript.rhino.jstype.JSType
          com.google.javascript.rhino.jstype.ObjectType
              com.google.javascript.rhino.jstype.TemplateType

All Implemented Interfaces:
  StaticScope<JSType>, Serializable

    public class TemplateType

extends ObjectType

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.ObjectType
`ObjectType.Property`

Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.JSType
`JSType.TypePair`

Field Summary

Fields inherited from class com.google.javascript.rhino.jstype.JSType
`EMPTY_TYPE_COMPONENT, ENUMDECL, NOT_A_CLASS, NOT_A_TYPE, NOT_ENUMDECL, UNKNOWN_NAME`

Method Summary
`boolean` | `canAssignTo(JSType that)` Tests whether values of `this` type can be safely assigned to values of `that` type.
`boolean` | `canBeCalled()` This predicate is used to test whether a given type can be used as the 'function' in a function call.
`JSType` | `collapseUnion()` Gets the least supertype of this that's not a union.
`protected void` | `collectPropertyNames(Set<String> props)` Adds any properties defined on this type or its supertypes to the set.
`JSType` | `findPropertyType(String propertyName)` Coerces this type to an Object type, then gets the type of the property whose name is given.
`FunctionType` | `getConstructor()` Gets this object's constructor.
`Iterable<ObjectType>` | `getCtorImplementedInterfaces()` Gets the interfaces implemented by the ctor associated with this type.
`ObjectType` | `getImplicitPrototype()` Gets the implicit prototype (a.k.a.
`JSType` | `getIndexType()` Gets the declared default index type.
`JSDocInfo` | `getJSDocInfo()` Gets the docInfo for this type.
`FunctionType` | `getOwnerFunction()` Gets the owner of this if it's a function prototype.
`JSDocInfo` | `getOwnPropertyJSDocInfo(String propertyName)` Gets the docInfo on the specified property on this type.
`Set<String>` | `getOwnPropertyNames()` Returns the names of all the properties directly on this type.
`JSType` | `getParameterType()` Gets the declared default element type.
`int` | `getPropertiesCount()` Gets the number of properties of this object.
`Node` | `getPropertyNode(String propertyName)` Gets the node corresponding to the definition of the specified property.
`JSType` | `getPropertyType(String propertyName)` Gets the property type of the property whose name is given.
`String` | `getReferenceName()` Gets the reference name for this object.
`ObjectType.Property` | `getSlot(String name)` Returns any defined slot within this scope for this name.
`ObjectType` | `getTypeOfThis()` Returns the expected type of `this` in the current scope.
`int` | `hashCode()`
`boolean` | `hasOwnProperty(String propertyName)` Checks whether the property whose name is given is present directly on the object.
`boolean` | `hasProperty(String propertyName)` Checks whether the property whose name is given is present on the object.
`boolean` | `hasReferenceName()` Returns true if the object is named.
`boolean` | `isAllType()`
`boolean` | `isCheckedUnknownType()`
`boolean` | `isConstructor()` Whether this type is a `FunctionType` that is a constructor or a named type that points to such a type.
`boolean` | `isEquivalentTo(JSType that)` Checks if two types are equivalent.
`boolean` | `isInstanceType()` Whether this type is an Instance object of some constructor.
`boolean` | `isInterface()` Whether this type is a `FunctionType` that is an interface or a named type that points to such a type.
`boolean` | `isNativeObjectType()` Whether this is a built-in object.
`boolean` | `isNominalType()` Whether this type is a nominal type (a named instance object or a named enum).
`boolean` | `isNoObjectType()`
`boolean` | `isNoResolvedType()`
`boolean` | `isNoType()`
`boolean` | `isNullable()` Tests whether this type is nullable.
`boolean` | `isOrdinaryFunction()` Whether this type is a `FunctionType` that is an ordinary function or a named type that points to such a type.
`boolean` | `isPropertyInExterns(String propertyName)` Checks whether the property was defined in the externs.
`boolean` | `isPropertyTypeDeclared(String propertyName)` Checks whether the property's type is declared.
`boolean` | `isPropertyTypeInferred(String propertyName)` Checks whether the property's type is inferred.
`boolean` | `isSubtype(JSType that)` Checks whether `this` is a subtype of `that`.
`boolean` | `isTemplateType()`
`boolean` | `isUnknownType()` We treat this as the unknown type if any of its implicit prototype properties is unknown.
`void` | `matchConstraint(ObjectType contraint)` Modify this type so that it matches the specified type.
`boolean` | `matchesNumberContext()` This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.
`boolean` | `matchesObjectContext()` This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement.
`boolean` | `matchesStringContext()` This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator.
`boolean` | `removeProperty(String name)` Removes the declared or inferred property from this ObjectType.
`void` | `setJSDocInfo(JSDocInfo info)` Sets the docInfo for this type from the given `JSDocInfo`.
`void` | `setPropertyJSDocInfo(String propertyName, JSDocInfo info)` Sets the docInfo for the specified property from the `JSDocInfo` on its definition.
`TernaryValue` | `testForEquality(JSType that)` Compares `this` and `that`.
`String` | `toDebugHashCodeString()` A hash code function for diagnosing complicated issues around type-identity.
`EnumElementType` | `toMaybeEnumElementType()` Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.
`EnumType` | `toMaybeEnumType()` Downcasts this to an EnumType, or returns null if this is not an EnumType.
`FunctionType` | `toMaybeFunctionType()` Downcasts this to a FunctionType, or returns null if this is not a function.
`UnionType` | `toMaybeUnionType()` Downcasts this to a UnionType, or returns null if this is not a UnionType.

`

`<T> T`

`

`visit(Visitor<T> visitor)`
Visit this type with the given visitor.

Methods inherited from class com.google.javascript.rhino.jstype.ObjectType
`cast, clearCachedValues, createDelegateSuffix, defineDeclaredProperty, defineInferredProperty, getCtorExtendedInterfaces, getDisplayName, getNormalizedReferenceName, getOwnSlot, getParentScope, getPossibleToBooleanOutcomes, getPropertyNames, getRootNode, hasCachedValues, isFunctionPrototypeType, isObject`

Methods inherited from class com.google.javascript.rhino.jstype.JSType

`autobox, autoboxesTo, canTestForEqualityWith, canTestForShallowEqualityWith, clearResolved, dereference, differsFrom, equals, forceResolve, getGreatestSubtype, getLeastSupertype, getRestrictedTypeGivenToBooleanOutcome, getTypesUnderEquality, getTypesUnderInequality, getTypesUnderShallowEquality, getTypesUnderShallowInequality, hasDisplayName, isArrayType, isBooleanObjectType, isBooleanValueType, isDateType, isEmptyType, isEnumElementType, isEnumType, isEquivalent, isFunctionType, isGlobalThisType, isNominalConstructor, isNullType, isNumber, isNumberObjectType, isNumberValueType, isRecordType, isRegexpType, isResolved, isString, isStringObjectType, isStringValueType, isUnionType, isVoidType, matchesInt32Context, matchesUint32Context, resolve, restrictByNotNullOrUndefined, setValidator, toAnnotationString, toMaybeFunctionType, toObjectType, toString, unboxesTo`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getReferenceName

    public String getReferenceName()

  Description copied from class: `ObjectType`
  Gets the reference name for this object. This includes named types like constructors, prototypes, and enums. It notably does not include literal types like strings and booleans and structural types.

  Returns:
    the object's name or `null` if this is an anonymous object

### isTemplateType

    public boolean isTemplateType()

  Overrides:
    `isTemplateType` in class `JSType`

### getSlot

    public ObjectType.Property getSlot(String name)

  Description copied from interface: `StaticScope`
  Returns any defined slot within this scope for this name. This call continues searching through parent scopes if a slot with this name is not found in the current scope.

  Specified by:
    `getSlot` in interface `StaticScope<JSType>`
  Specified by:
    `getSlot` in class `ObjectType`
  Parameters:
    `name` - The name of the variable slot to look up.
  Returns:
    The defined slot for the variable, or `null` if no definition exists.

### hasReferenceName

    public boolean hasReferenceName()

  Description copied from class: `ObjectType`
  Returns true if the object is named.

  Overrides:
    `hasReferenceName` in class `ObjectType`
  Returns:
    true if the object is named, false if it is anonymous

### matchesNumberContext

    public boolean matchesNumberContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.

  Overrides:
    `matchesNumberContext` in class `JSType`

### matchesStringContext

    public boolean matchesStringContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator. All types have at least the potential for converting to `String`. When we add externally defined types, such as a browser OM, we may choose to add types that do not automatically convert to `String`.

  Overrides:
    `matchesStringContext` in class `JSType`

### matchesObjectContext

    public boolean matchesObjectContext()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement. Most types we will encounter, except notably `null`, have at least the potential for converting to `Object`. Host defined objects can get peculiar.

  Overrides:
    `matchesObjectContext` in class `JSType`

### canBeCalled

    public boolean canBeCalled()

  Description copied from class: `JSType`
  This predicate is used to test whether a given type can be used as the 'function' in a function call.

  Overrides:
    `canBeCalled` in class `JSType`
  Returns:
    `true` if this type might be callable.

### isNoType

    public boolean isNoType()

  Overrides:
    `isNoType` in class `JSType`

### isNoObjectType

    public boolean isNoObjectType()

  Overrides:
    `isNoObjectType` in class `JSType`

### isNoResolvedType

    public boolean isNoResolvedType()

  Overrides:
    `isNoResolvedType` in class `JSType`

### isUnknownType

    public boolean isUnknownType()

  Description copied from class: `ObjectType`
  We treat this as the unknown type if any of its implicit prototype properties is unknown.

  Overrides:
    `isUnknownType` in class `ObjectType`

### isCheckedUnknownType

    public boolean isCheckedUnknownType()

  Overrides:
    `isCheckedUnknownType` in class `JSType`

### isNullable

    public boolean isNullable()

  Description copied from class: `JSType`
  Tests whether this type is nullable.

  Overrides:
    `isNullable` in class `JSType`

### toMaybeEnumType

    public EnumType toMaybeEnumType()

  Description copied from class: `JSType`
  Downcasts this to an EnumType, or returns null if this is not an EnumType.

  Overrides:
    `toMaybeEnumType` in class `JSType`

### isConstructor

    public boolean isConstructor()

  Description copied from class: `JSType`
  Whether this type is a `FunctionType` that is a constructor or a named type that points to such a type.

  Overrides:
    `isConstructor` in class `JSType`

### isNominalType

    public boolean isNominalType()

  Description copied from class: `JSType`
  Whether this type is a nominal type (a named instance object or a named enum).

  Overrides:
    `isNominalType` in class `JSType`

### isInstanceType

    public boolean isInstanceType()

  Description copied from class: `JSType`
  Whether this type is an Instance object of some constructor. Does not necessarily mean this is an `InstanceObjectType`.

  Overrides:
    `isInstanceType` in class `JSType`

### isInterface

    public boolean isInterface()

  Description copied from class: `JSType`
  Whether this type is a `FunctionType` that is an interface or a named type that points to such a type.

  Overrides:
    `isInterface` in class `JSType`

### isOrdinaryFunction

    public boolean isOrdinaryFunction()

  Description copied from class: `JSType`
  Whether this type is a `FunctionType` that is an ordinary function or a named type that points to such a type.

  Overrides:
    `isOrdinaryFunction` in class `JSType`

### isAllType

    public boolean isAllType()

  Overrides:
    `isAllType` in class `JSType`

### isNativeObjectType

    public boolean isNativeObjectType()

  Description copied from class: `ObjectType`
  Whether this is a built-in object.

  Overrides:
    `isNativeObjectType` in class `ObjectType`

### toMaybeUnionType

    public UnionType toMaybeUnionType()

  Description copied from class: `JSType`
  Downcasts this to a UnionType, or returns null if this is not a UnionType. Named in honor of Haskell's Maybe type constructor.

  Overrides:
    `toMaybeUnionType` in class `JSType`

### toMaybeFunctionType

    public FunctionType toMaybeFunctionType()

  Description copied from class: `JSType`
  Downcasts this to a FunctionType, or returns null if this is not a function. For the purposes of this function, we define a MaybeFunctionType as any type in the sub-lattice { x | LEAST_FUNCTION_TYPE <= x <= GREATEST_FUNCTION_TYPE } This definition excludes bottom types like NoType and NoObjectType. This definition is somewhat arbitrary and axiomatic, but this is the definition that makes the most sense for the most callers.

  Overrides:
    `toMaybeFunctionType` in class `JSType`

### toMaybeEnumElementType

    public EnumElementType toMaybeEnumElementType()

  Description copied from class: `JSType`
  Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.

  Overrides:
    `toMaybeEnumElementType` in class `JSType`

### testForEquality

    public TernaryValue testForEquality(JSType that)

  Description copied from class: `JSType`
  Compares `this` and `that`.

  Overrides:
    `testForEquality` in class `ObjectType`
  Returns:
    - `TernaryValue.TRUE` if the comparison of values of `this` type and `that` always succeed (such as `undefined` compared to `null`)
    - `TernaryValue.FALSE` if the comparison of values of `this` type and `that` always fails (such as `undefined` compared to `number`)
    - `TernaryValue.UNKNOWN` if the comparison can succeed or fail depending on the concrete values

### isSubtype

    public boolean isSubtype(JSType that)

  Description copied from class: `JSType`
  Checks whether `this` is a subtype of `that`.

  Subtyping rules:

  - (unknown) — every type is a subtype of the Unknown type.
  - (no) — the No type is a subtype of every type.
  - (no-object) — the NoObject type is a subtype of every object type (i.e. subtypes of the Object type).
  - (ref) — a type is a subtype of itself.
  - (union-l) — A union type is a subtype of a type U if all the union type's constituents are a subtype of U. Formally
    `(T<sub>1</sub>, &hellip;, T<sub>n</sub>) &lt;: U` if and only `T<sub>k</sub> &lt;: U` for all `k &isin; 1..n`.
  - (union-r) — A type U is a subtype of a union type if it is a subtype of one of the union type's constituents. Formally
    `U &lt;: (T<sub>1</sub>, &hellip;, T<sub>n</sub>)` if and only if `U &lt;: T<sub>k</sub>` for some index `k`.
  - (objects) — an Object `O<sub>1</sub>` is a subtype of an object `O<sub>2</sub>` if it has more properties than `O<sub>2</sub>` and all common properties are pairwise subtypes.

  Overrides:
    `isSubtype` in class `JSType`
  Returns:
    `this &lt;: that`

### getOwnerFunction

    public FunctionType getOwnerFunction()

  Description copied from class: `ObjectType`
  Gets the owner of this if it's a function prototype.

  Overrides:
    `getOwnerFunction` in class `ObjectType`

### getCtorImplementedInterfaces

    public Iterable<ObjectType> getCtorImplementedInterfaces()

  Description copied from class: `ObjectType`
  Gets the interfaces implemented by the ctor associated with this type. Intended to be overridden by subclasses.

  Overrides:
    `getCtorImplementedInterfaces` in class `ObjectType`

### canAssignTo

    public boolean canAssignTo(JSType that)

  Description copied from class: `JSType`
  Tests whether values of `this` type can be safely assigned to values of `that` type.

  The default implementation verifies that `this` is a subtype of `that`.

  Overrides:
    `canAssignTo` in class `JSType`

### isEquivalentTo

    public boolean isEquivalentTo(JSType that)

  Description copied from class: `JSType`
  Checks if two types are equivalent.

  Overrides:
    `isEquivalentTo` in class `JSType`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `JSType`

### getImplicitPrototype

    public ObjectType getImplicitPrototype()

  Description copied from class: `ObjectType`
  Gets the implicit prototype (a.k.a. the `[[Prototype]]` property).

  Specified by:
    `getImplicitPrototype` in class `ObjectType`

### removeProperty

    public boolean removeProperty(String name)

  Description copied from class: `ObjectType`
  Removes the declared or inferred property from this ObjectType.

  Overrides:
    `removeProperty` in class `ObjectType`
  Parameters:
    `name` - the property's name
  Returns:
    true if the property was removed successfully. False if the property did not exist, or could not be removed.

### isPropertyTypeDeclared

    public boolean isPropertyTypeDeclared(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property's type is declared.

  Specified by:
    `isPropertyTypeDeclared` in class `ObjectType`

### getPropertyNode

    public Node getPropertyNode(String propertyName)

  Description copied from class: `ObjectType`
  Gets the node corresponding to the definition of the specified property. This could be the node corresponding to declaration of the property or the node corresponding to the first reference to this property, e.g., "this.propertyName" in a constructor. Note this is mainly intended to be an estimate of where in the source code a property is defined. Sometime the returned node is not even part of the global AST but in the AST of the JsDoc that defines a type.

  Overrides:
    `getPropertyNode` in class `ObjectType`
  Parameters:
    `propertyName` - the name of the property
  Returns:
    the `Node` corresponding to the property or null.

### isPropertyTypeInferred

    public boolean isPropertyTypeInferred(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property's type is inferred.

  Specified by:
    `isPropertyTypeInferred` in class `ObjectType`

### isPropertyInExterns

    public boolean isPropertyInExterns(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property was defined in the externs.

  Overrides:
    `isPropertyInExterns` in class `ObjectType`

### getPropertiesCount

    public int getPropertiesCount()

  Description copied from class: `ObjectType`
  Gets the number of properties of this object.

  Specified by:
    `getPropertiesCount` in class `ObjectType`

### collectPropertyNames

    protected void collectPropertyNames(Set<String> props)

  Description copied from class: `ObjectType`
  Adds any properties defined on this type or its supertypes to the set.

### findPropertyType

    public JSType findPropertyType(String propertyName)

  Description copied from class: `JSType`
  Coerces this type to an Object type, then gets the type of the property whose name is given. Unlike `ObjectType.getPropertyType(java.lang.String)`, returns null if the property is not found.

  Overrides:
    `findPropertyType` in class `ObjectType`
  Returns:
    The property's type. `null` if the current type cannot have properties, or if the type is not found.

### getPropertyType

    public JSType getPropertyType(String propertyName)

  Description copied from class: `ObjectType`
  Gets the property type of the property whose name is given. If the underlying object does not have this property, the Unknown type is returned to indicate that no information is available on this property.

  Specified by:
    `getPropertyType` in class `ObjectType`
  Returns:
    the property's type or `UnknownType`. This method never returns `null`.

### getJSDocInfo

    public JSDocInfo getJSDocInfo()

  Description copied from class: `ObjectType`
  Gets the docInfo for this type.

  Overrides:
    `getJSDocInfo` in class `ObjectType`

### setJSDocInfo

    public void setJSDocInfo(JSDocInfo info)

  Description copied from class: `ObjectType`
  Sets the docInfo for this type from the given `JSDocInfo`. The `JSDocInfo` may be `null`.

  Overrides:
    `setJSDocInfo` in class `ObjectType`

### getOwnPropertyJSDocInfo

    public JSDocInfo getOwnPropertyJSDocInfo(String propertyName)

  Description copied from class: `ObjectType`
  Gets the docInfo on the specified property on this type. This should not be done implemented recursively, as you generally need to know exactly on which type in the prototype chain the JSDocInfo exists.

  Overrides:
    `getOwnPropertyJSDocInfo` in class `ObjectType`

### setPropertyJSDocInfo

    public void setPropertyJSDocInfo(String propertyName,
                                     JSDocInfo info)

  Description copied from class: `ObjectType`
  Sets the docInfo for the specified property from the `JSDocInfo` on its definition.

  Overrides:
    `setPropertyJSDocInfo` in class `ObjectType`
    `info` - `JSDocInfo` for the property definition. May be `null`.

### hasProperty

    public boolean hasProperty(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property whose name is given is present on the object.

  Specified by:
    `hasProperty` in class `ObjectType`

### hasOwnProperty

    public boolean hasOwnProperty(String propertyName)

  Description copied from class: `ObjectType`
  Checks whether the property whose name is given is present directly on the object. Returns false even if it is declared on a supertype.

  Overrides:
    `hasOwnProperty` in class `ObjectType`

### getOwnPropertyNames

    public Set<String> getOwnPropertyNames()

  Description copied from class: `ObjectType`
  Returns the names of all the properties directly on this type.

  Overrides:
    `getOwnPropertyNames` in class `ObjectType`

### getConstructor

    public FunctionType getConstructor()

  Description copied from class: `ObjectType`
  Gets this object's constructor.

  Specified by:
    `getConstructor` in class `ObjectType`
  Returns:
    this object's constructor or `null` if it is a native object (constructed natively v.s. by instantiation of a function)

### getParameterType

    public JSType getParameterType()

  Description copied from class: `ObjectType`
  Gets the declared default element type.

  Overrides:
    `getParameterType` in class `ObjectType`
  See Also:
    `ParameterizedType`

### getIndexType

    public JSType getIndexType()

  Description copied from class: `ObjectType`
  Gets the declared default index type.

  Overrides:
    `getIndexType` in class `ObjectType`
  See Also:
    `IndexedType`

### visit

    public <T> T visit(Visitor<T> visitor)

  Description copied from class: `JSType`
  Visit this type with the given visitor.

  Overrides:
    `visit` in class `ObjectType`
  Returns:
    the value returned by the visitor
  See Also:
    `Visitor`

### toDebugHashCodeString

    public String toDebugHashCodeString()

  Description copied from class: `JSType`
  A hash code function for diagnosing complicated issues around type-identity.

  Overrides:
    `toDebugHashCodeString` in class `JSType`

### getTypeOfThis

    public ObjectType getTypeOfThis()

  Description copied from interface: `StaticScope`
  Returns the expected type of `this` in the current scope.

  Specified by:
    `getTypeOfThis` in interface `StaticScope<JSType>`
  Overrides:
    `getTypeOfThis` in class `ObjectType`

### collapseUnion

    public JSType collapseUnion()

  Description copied from class: `JSType`
  Gets the least supertype of this that's not a union.

  Overrides:
    `collapseUnion` in class `JSType`

### matchConstraint

    public void matchConstraint(ObjectType contraint)

  Description copied from class: `JSType`
  Modify this type so that it matches the specified type. This is useful for reverse type-inference, where we want to infer that an object literal matches its contraint (much like how the java compiler does reverse-inference to figure out generics).

  Overrides:
    `matchConstraint` in class `JSType`